<?php

class CosmicBlocks_Register
{
	private static function options()
	{
		return [
			'cosmic_blocks_accordion' => '1',
			'cosmic_blocks_advantages' => '1',
			'cosmic_blocks_brands' => '1',
			'cosmic_blocks_buttons' => '1',
			'cosmic_blocks_classifieds_list' => '1',
			'cosmic_blocks_classifieds_tiles' => '1',
			'cosmic_blocks_contacts_list' => '1',
			'cosmic_blocks_contacts_target_bar' => '1',
			'cosmic_blocks_contacts_tiles' => '1',
			'cosmic_blocks_container' => '1',
			'cosmic_blocks_container_fancy_animated' => '1',
			'cosmic_blocks_countdown' => '1',
			'cosmic_blocks_countup' => '1',
			'cosmic_blocks_date_list' => '1',
			'cosmic_blocks_date_tiles' => '1',
			'cosmic_blocks_deals' => '1',
			'cosmic_blocks_donations' => '1',
			'cosmic_blocks_donations_stripe_publishable' => '',
			'cosmic_blocks_donations_stripe_secret' => '',
			'cosmic_blocks_donations_stripe_currency' => 'usd',
			'cosmic_blocks_employee_list' => '1',
			'cosmic_blocks_employee' => '1',
			'cosmic_blocks_events_list' => '1',
			'cosmic_blocks_events_tiles' => '1',
			'cosmic_blocks_events_upcoming_list' => '1',
			'cosmic_blocks_events_upcoming_tiles' => '1',
			'cosmic_blocks_facts' => '1',
			'cosmic_blocks_foreword' => '1',
			'cosmic_blocks_image' => '1',
			'cosmic_blocks_greeting' => '1',
			'cosmic_blocks_inline_notice' => '1',
			'cosmic_blocks_launch' => '1',
			'cosmic_blocks_like_dislike' => '1',
			'cosmic_blocks_linklist_downloads' => '1',
			'cosmic_blocks_linklist_icons' => '1',
			'cosmic_blocks_linklist_images' => '1',
			'cosmic_blocks_linklist_images_slide' => '1',
			'cosmic_blocks_links_list' => '1',
			'cosmic_blocks_posts_list' => '1',
			'cosmic_blocks_posts_tiles' => '1',
			'cosmic_blocks_pricebox' => '1',
			'cosmic_blocks_pricelist' => '1',
			'cosmic_blocks_progress' => '1',
			'cosmic_blocks_separator' => '1',
			'cosmic_blocks_showcase' => '1',
			'cosmic_blocks_social_share' => '1',
			'cosmic_blocks_split_list' => '1',
			'cosmic_blocks_statement' => '1',
			'cosmic_blocks_steps' => '1',
			'cosmic_blocks_testimonial' => '1',
			'cosmic_blocks_title_intro' => '1',
			'cosmic_blocks_voting_slogans' => '1',
			'cosmic_blocks_wanted' => '1',
			'cosmic_blocks_main_padding_top' => '',
			'cosmic_blocks_main_padding_bottom' => '',
			'cosmic_blocks_main_intro_padding_bottom' => '',
			'cosmic_blocks_mobile_main_padding_top' => '',
			'cosmic_blocks_mobile_main_padding_bottom' => '',
			'cosmic_blocks_mobile_main_intro_padding_bottom' => '',
			'cosmic_blocks_dependency_check' => '1',
			'cosmic_blocks_front_block' => 'disabled',
			'cosmic_blocks_editor_block' => '1',
			'cosmic_blocks_editor_block_width' => '',
			'cosmic_blocks_editor_block_wide_width' => '',
			'cosmic_blocks_front_block_simple_small' => '',
			'cosmic_blocks_front_block_simple_wide' => '',
			'cosmic_blocks_front_block_custom_query' => '',
			'cosmic_blocks_front_block_custom_small' => '',
			'cosmic_blocks_front_block_custom_wide' => ''
		];
	}
	
	/**
	 * fires on activate plugin
	 * add initial options to settings page
	 * register schedule events
	 */
	public static function activate()
	{
		self::flushed(false);
		
		foreach(self::options() as $option => $value)
		{
			if(!get_option($option))
			{
				add_option($option, $value);
			}
		}
    }
	
	/**
	 * fires on deactivate plugin
	 * unregister schedule events
	 */
	public static function deactivate()
	{
		//self::uninstall();
	}
	
	/**
	 * fires on activate plugin
	 * delete options
	 */
	public static function uninstall()
	{
		foreach(self::options() as $option => $value)
		{
			if(get_option($option))
			{
				delete_option($option);
			}
		}
	}
	
	/**
	 * set flushed
	 * @param type $status
	 */
	public static function flushed($status = true)
	{
		if($status === true)
		{
			if(!get_option('cosmic_blocks_permalinks_flushed'))
			{
				add_option('cosmic_blocks_permalinks_flushed', true);
			}
		}
		else if($status === false)
		{
			if(get_option('cosmic_blocks_permalinks_flushed'))
			{
				delete_option('cosmic_blocks_permalinks_flushed');
			}
		}
	}
}